upstream backend_group {
    server {{ web_server_backend_host }}:{{ web_server_backend_port }};
}

{% if not (web_server_static_frontend | bool and web_server_no_frontend | bool) %}
    upstream frontend_group {
        server {{ web_server_dynamic_frontend_host }}:{{ web_server_dynamic_frontend_port }};
    }
{% endif %}

{% macro routing() %}
    {% if web_server_enable_www | bool and web_server_www_use_redirect | bool %}
    if ($host = www.{{ web_server_app_domain }}) {
        return 301 https://{{ web_server_app_domain }}$request_uri$is_args$args;
    }
    {% endif %}

    {% if web_server_no_frontend | bool %}
        location / {
            include {{ nginx_conf_directory }}/proxy.conf;
            proxy_pass http://backend_group$uri$is_args$args;
        }
    {% else %}
        {% if web_server_static_frontend | bool %}
        location / {
            root {{ web_server_frontend_deployment_path }};
            try_files $uri $uri/ /index.html;
        }
        {% else %}
        location / {
            include {{ nginx_conf_directory }}/proxy.conf;
            proxy_pass http://frontend_group$uri$is_args$args;
        }
        {% endif %}

        location ~ ^/({{ web_server_backend_uri_list | list | join("|") }})(?:/|$) {
            include {{ nginx_conf_directory }}/proxy.conf;
            proxy_pass http://backend_group$uri$is_args$args;
        }

        location @backend_proxy {
            include {{ nginx_conf_directory }}/proxy.conf;
            proxy_pass http://backend_group$uri$is_args$args;
        }

        {% for rule in web_server_nginx_proxy_rules %}
        location {{ rule["location"] }} {
            {% if rule.get("headers") %}
            {% for header, value in rule["headers"].items() %}
            add_header {{ header }} {{ value }};
            {% endfor %}
            {% endif %}

            {% if rule.get("query") %}
            set $args $args{{ rule["query"] }};
            {% endif %}

            proxy_pass {{ rule["target"] }};
        }
        {% endfor %}
    {% endif %}

    {% if web_server_nginx_serve_backend_static | bool %}
    location /{{ web_server_nginx_backend_static_uri }} {
        access_log off;
        log_not_found off;
        alias {{ web_server_nginx_backend_static_path }};
    }
    {% endif %}
{% endmacro %}

{% if web_server_enable_https | bool and web_server_use_local_cert | bool %}
server {
    listen {{ web_server_listen_ipv4_address | ternary(web_server_listen_ipv4_address + ":", "") }}{{ nginx_http_listen_port }};
    listen [{{ web_server_listen_ipv6_address }}]:{{ nginx_http_listen_port }};
    server_name {{ web_server_app_domain }}{% if web_server_enable_www | bool %} {{ web_server_app_domain }}{% endif %};
    charset     utf-8;

    {% if web_server_enable_https_redirect | bool %}
    if ($host = {{ web_server_app_domain }}) {
        return 301 https://{{ web_server_app_domain }}$request_uri$is_args$args;
    }
    {% if web_server_enable_www | bool %}
    if ($host = www.{{ web_server_app_domain }}) {
        return 301 https://{% if not web_server_www_use_redirect | bool %}www.{% endif %}{{ web_server_app_domain }}$request_uri$is_args$args;
    }
    {% endif %}

    return 404;
    {% else %}
    {{ routing() }}
    {% endif %}
}

server {
    listen {{web_server_listen_ipv4_address | ternary(web_server_listen_ipv4_address + ":", "")}}{{nginx_https_listen_port}} http2 ssl;
    listen [{{web_server_listen_ipv6_address}}]:{{nginx_https_listen_port}} http2 ssl;
    server_name {{web_server_app_domain}}{% if web_server_enable_www | bool %} www.{{web_server_app_domain}}{% endif %};
    charset     utf-8;

    include {{ nginx_ssl_conf_path }};
	ssl_certificate {{web_server_ssl_cert_path}};
	ssl_certificate_key {{web_server_ssl_key_path}};

    {{ routing() }}
}
{% else %}
server {
    listen {{web_server_listen_ipv4_address | ternary(web_server_listen_ipv4_address + ":", "")}}{{nginx_http_listen_port}};
    listen [{{web_server_listen_ipv6_address}}]:{{nginx_http_listen_port}};
    server_name {{web_server_app_domain}}{% if web_server_enable_www | bool %} www.{{web_server_app_domain}}{% endif %};
    charset     utf-8;

    {{ routing() }}
}
{% endif %}
